' ============================================================
' Module Name: Master_Z4_221
' Module Desc: Z4 master data management (221)
' Module Methods:
'   - Worksheet_Change
'   - Validate
' ============================================================

' ============================================================
' Event Handlers
' ============================================================
Private Sub Worksheet_Change(ByVal Target As Range)
    Dim HasHeaderEdit As Boolean: HasHeaderEdit = CheckHeaderEdit(Me, Target)
    If HasHeaderEdit = True Then Exit Sub

End Sub

' Prevent insert/delete row in header area
Private Sub Worksheet_BeforeRightClick(ByVal Target As Range, Cancel As Boolean)
    Dim sheetConfDict As Object: Set sheetConfDict = GetSheetConfig()
    Dim sheetConf As Object: Set sheetConf = sheetConfDict(Me.CodeName)
    Dim filterRow As Long: filterRow = sheetConf("FilterRow")

    If Target.Row < filterRow + 1 Then
        Cancel = True
        MsgBox "Cannot insert or delete row in header area.", vbExclamation
    End If
End Sub

' 
Public Sub Validate(ws As Worksheet, ByVal rowNum As Long, ByVal lastDataRow As Long)
    On Error GoTo ErrHandler
    
    Dim sheetConfDict As Object: Set sheetConfDict = GetSheetConfig()
    Dim sheetConf As Object: Set sheetConf = sheetConfDict(ws.CodeName)

    Dim startCol As String: startCol = sheetConf("StartCol")
    Dim endCol As String: endCol = sheetConf("EndCol")
    Dim errorCol As String: errorCol = sheetConf("ErrorCol")
    
    ' clear C~I columns background color
    Dim clearRange As Range: Set clearRange = ws.Range(ws.Cells(rowNum, startCol), ws.Cells(rowNum, endCol))
    clearRange.Interior.Color = vbWhite
    
    ' C column check
    checkResult = CheckRequired(ws, rowNum, 3, errorCol)
    If checkResult = False Then Exit Sub

    checkResult = CheckChar(ws, rowNum, 3, 2, errorCol)
    If checkResult = False Then Exit Sub

    checkResult = CheckAlphanumeric(ws, rowNum, 3, 2, errorCol)
    If checkResult = False Then Exit Sub

    checkResult = CheckDuplicate(ws, rowNum, 3, errorCol)
    If checkResult = False Then Exit Sub
    
    ' D column check
    checkResult = CheckRequired(ws, rowNum, 4, errorCol)
    If checkResult = False Then Exit Sub

    checkResult = CheckVarcharOver(ws, rowNum, 4, 80, errorCol)
    If checkResult = False Then Exit Sub

    ' E column check
    checkResult = CheckVarcharOver(ws, rowNum, 5, 80, errorCol)
    If checkResult = False Then Exit Sub
    
    ' F column check
    checkResult = CheckVarcharOver(ws, rowNum, 6, 80, errorCol)
    If checkResult = False Then Exit Sub

    ' G column check
    checkResult = CheckVarcharOver(ws, rowNum, 7, 80, errorCol)
    If checkResult = False Then Exit Sub
    
    ' H column check
    checkResult = Check01(ws, rowNum, 8, errorCol)
    If checkResult = False Then Exit Sub

    ws.Cells(rowNum, errorCol).ClearContents
    Exit Sub

ErrHandler:
    lastErrorMsg = Err.Description
End Sub
